#include "kdmapper.hpp"

int main(const int argc, char** argv)
{	
	if (argc != 2 || std::filesystem::path(argv[1]).extension().string().compare(".sys"))
	{
		std::cout << "[-] Incorrect usage" << std::endl;
		return -1;
	}

	const std::string driver_path = argv[1];

	if (!std::filesystem::exists(driver_path))
	{
		std::cout << "[-] File " << driver_path << " doesn't exist" << std::endl;
		return -1;
	}

	HANDLE iqvw64e_device_handle = nullptr; // dummy handle because I am lazy piece of shit
	
	bool status = efi_driver::Init();
	if (!status) 
	{
		std::cout << "[-] Failed to init driver" << std::endl;
		return -1;
	}

	if (!kdmapper::MapDriver(iqvw64e_device_handle, driver_path))
	{
		std::cout << "[-] Failed to map " << driver_path << std::endl;
		return -1;
	}

	std::cout << "[+] success" << std::endl;
}